﻿@dryRun
Feature: Dry-run support for synchronization

Rule: For new scenarios, the Test Case should not be created and the feature file should not be changed with dry-run mode

@tc:592
Scenario: New scenario is pushed in dry-run mode
	Given there is a remote server project
	And there is a scenario in the local repository
		"""
		Scenario: Sample scenario
			When I do something
		"""
	When the local repository is synchronized with push in dry-run mode
	Then no Test Case should be created with title "Scenario: Sample scenario" in the remote server
	And the feature file in the local repository should not change

Rule: For existing scenarios, the Test Case should not be updated with dry-run mode

@tc:593
Scenario: Updated scenario is pushed in dry-run mode
	Given there is a remote server project
	And there is an existing synchronized scenario that has been changed to:
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario
			When I do something
		"""
	When the local repository is synchronized with push in dry-run mode
	Then the Test Case title should not be updated to "Scenario: Updated scenario" in the remote server

Rule: The Test Suites should not be updated with dry-run mode

@tc:594 @adoSpecific
Scenario: A scenario that was not included in a Test Suite is pushed in dry-run mode
	Given there is an Azure DevOps project with an empty Test Suite 'MySuite'
	And there is an existing synchronized scenario
		"""
		Scenario: Sample scenario
			When I do something
		"""
	And the synchronizer is configured to add Test Cases to Test Suite 'MySuite'
	When the local repository is synchronized with push in dry-run mode
	Then the Test Suite should be empty

Rule: Local workspace should not be changed during pull with dry-run mode

@tc:595
Scenario: A remote Test Case change is pulled in dry-run mode
	Given there is a remote server project
	And the synchronizer is configured to enable pull
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	And the Test Case title has been updated to 'Scenario: Updated scenario on remote'
	When the local repository is synchronized with pull in dry-run mode
	Then the feature file in the local repository should not change
