﻿@pull @bypass-integration
Feature: Pull - Conflict handling

Background: 
	Given there is a remote server project
	And the synchronizer is configured to enable pull
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	When the Test Case title should be updated to 'Scenario: Updated scenario on remote'
	When the scenario is updated to:
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario on local
			When I do something new
		"""

@tc:199
Scenario: Both the test case and the scenario were changed (interactive pull conflict)
	When SpecSync pull is executed with choosing "Remote" for conflict
	Then the feature file in the local repository should be updated to:
		"""
		Feature: Sample feature
		@tc:[id-of-test-case]
		Scenario: Updated scenario on remote
			When I do something
		"""

@tc:200
Scenario: Quit from interactive pull conflict
	When SpecSync pull is executed with choosing "Quit" for conflict
	Then the synchronization should finish with errors

@tc:1187
Scenario: Fail from interactive pull conflict
	When SpecSync pull is executed with choosing "Fail" for conflict
	Then the synchronization should finish with test case errors

@tc:201
Scenario: Skip from interactive pull conflict
	When SpecSync pull is executed with choosing "Skip" for conflict
	Then the synchronization should not fail

@tc:1188
Scenario: Pull overrides remote when force flag is used
	Given the synchronizer is configured to force updates
	When the local repository is synchronized with pull
	Then the feature file in the local repository should be updated to:
		"""
		Feature: Sample feature
		@tc:[id-of-test-case]
		Scenario: Updated scenario on remote
			When I do something
		"""

@tc:1189
Scenario: Pull conflict can automatically override local
	Given the synchronizer is configured as
		| setting                                 | value         |
		| synchronization/pull/conflictResolution | forceOverride |
	When the local repository is synchronized with pull
	Then the feature file in the local repository should be updated to:
		"""
		Feature: Sample feature
		@tc:[id-of-test-case]
		Scenario: Updated scenario on remote
			When I do something
		"""

@tc:1190
Scenario: Pull conflict can be automatically skipped with a warning
	Given the synchronizer is configured as
		| setting                                 | value |
		| synchronization/pull/conflictResolution | skip  |
	When the local repository is synchronized with pull
	Then the synchronization should finish with warnings

@tc:1191
Scenario: Pull conflict can automatically fail test case synchronization
	Given the synchronizer is configured as
		| setting                                 | value |
		| synchronization/pull/conflictResolution | error |
	When SpecSync pull is executed
	Then the synchronization should finish with test case errors

@tc:1192
Scenario: Pull conflict can be automatically ignored
	Given the synchronizer is configured as
		| setting                                 | value  |
		| synchronization/pull/conflictResolution | ignore |
	When the local repository is synchronized with pull
	Then the synchronization should not fail
	And the Test Case should not be changed