﻿@pull @bypass-integration
Feature: Pull - Failure Recovery

@tc:205
@edge
Scenario: Invalid Gherkin is synchronized back
	Given there is a remote server project
	And the synchronizer is configured to enable pull
	And there is an existing synchronized scenario outline
		"""
		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""
	When the Test Case steps are updated to 
		| keyword | text                                          |
		| When    | [[something]] really happens with [[someone]] |
		| Invalid | this is good for [[someone]]                  |
	And SpecSync pull is executed
	Then the synchronization should finish with warnings

@tc:206
@edge @specFlowCodeBehind 
#Cannot be tested in .NET Core. Featrue will be removed in v3.5, see #1205
@ignore
Scenario: The updated scenario is not vaild for SpecFlow v2 code-behind generation
	The step 'Invalid keyword' is not valid
	Given there is a remote server project
	And the synchronizer is configured to force generating feature file code-behinds
	And the synchronizer is configured to enable pull
	And there is an existing synchronized scenario outline
		"""
		Scenario Outline: Sample scenario outline
			When <something> happens with <someone>

		Examples:
			| something | someone |
			| foo       | Joe     |
			| bar       | Jill    |
			| boz       | Jack    | 
		"""
	When the Test Case title is updated to
		"""
		Scenario: hello
			When hello
			Invalid keyword

		Scenario Outline: Updated scenario outline
		"""
	And SpecSync pull is executed
	Then the synchronization should finish with errors
