﻿@bypass-integration
Feature: Push - Conflict handling

Background: 
	Given there is a remote server project
	And there is an existing synchronized scenario
		"""
		@tc:[id-of-test-case]
		Scenario: Sample scenario
			When I do something
		"""
	When the Test Case title should be updated to 'Scenario: Updated scenario on remote'
	When the scenario is updated to:
		"""
		@tc:[id-of-test-case]
		Scenario: Updated scenario on local
			When I do something new
		"""

@tc:1193
Scenario: Both the test case and the scenario were changed (interactive push conflict)
	Given the synchronizer is configured as
		| setting                                 | value       |
		| synchronization/push/conflictResolution | interactive |
	When the SpecSync push is executed with choosing "Local" for conflict
	Then the Test Case title should be updated to "Scenario: Updated scenario on local"
	And the Test Case should contain the following steps
		| step                    |
		| When I do something new |

@tc:1194
Scenario: Quit from interactive push conflict
	Given the synchronizer is configured as
		| setting                                 | value       |
		| synchronization/push/conflictResolution | interactive |
	When the SpecSync push is executed with choosing "Quit" for conflict
	Then the synchronization should finish with errors

@tc:1195
Scenario: Fail from interactive push conflict
	Given the synchronizer is configured as
		| setting                                 | value       |
		| synchronization/push/conflictResolution | interactive |
	When the SpecSync push is executed with choosing "Fail" for conflict
	Then the synchronization should finish with test case errors

@tc:1196
Scenario: Skip from interactive push conflict
	Given the synchronizer is configured as
		| setting                                 | value       |
		| synchronization/push/conflictResolution | interactive |
	When the SpecSync push is executed with choosing "Skip" for conflict
	Then the synchronization should not fail
	And the Test Case should be skipped

@tc:1197
Scenario: Push overrides remote when force flag is used
	Given the synchronizer is configured as
		| setting                                 | value       |
		| synchronization/push/conflictResolution | interactive |
	And the synchronizer is configured to force updates
	When SpecSync push is executed
	Then the Test Case title should be updated to "Scenario: Updated scenario on local"
	And the Test Case should contain the following steps
		| step                    |
		| When I do something new |

@tc:1198
Scenario: Push overrides remote by default
	When SpecSync push is executed
	Then the Test Case title should be updated to "Scenario: Updated scenario on local"
	And the Test Case should contain the following steps
		| step                    |
		| When I do something new |

@tc:1199
Scenario: Push conflict can be automatically skipped with a warning
	Given the synchronizer is configured as
		| setting                                 | value |
		| synchronization/push/conflictResolution | skip  |
	When SpecSync push is executed
	Then the synchronization should finish with warnings

@tc:1200
Scenario: Push conflict can automatically fail test case synchronization
	Given the synchronizer is configured as
		| setting                                 | value |
		| synchronization/push/conflictResolution | error |
	When SpecSync push is executed
	Then the synchronization should finish with test case errors

@tc:1201
Scenario: Push conflict can be automatically ignored
	Given the synchronizer is configured as
		| setting                                 | value  |
		| synchronization/push/conflictResolution | ignore |
	When SpecSync push is executed
	Then the synchronization should not fail
	And the Test Case should not be changed